var { data } = require("self");
var { SearchSettings } = require("search-settings");
var prefSet = require("simple-prefs");
var tabs = require("tabs");
var {Cc, Ci} = require("chrome");
var stringService = Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService);
var strings = stringService.createBundle("chrome://ecosia/locale/global.properties");
// Get the engine URL based on our URL.
const ENGINE_URL = data.url("search.xml");

exports.main = function main(options) {
    SearchSettings.init(options.loadReason);
    SearchSettings.addSearchEngine(ENGINE_URL, prefSet.prefs['keepdefault']);
	if(prefSet.prefs['newtabenabled'])
	{
    	SearchSettings.setPref("browser.newtab.url", "http://www.ecosia.org/?addon=firefox&ref=newtab-search");
	}
	prefSet.on('newtabenabled', onPrefChange);
	prefSet.on('keepdefault', onPrefChange);
	loadPageMod();
	if(options.loadReason == "install") tabs.open("http://www.ecosia.org/firstrun?addon=firefox");
}

function onPrefChange(prefName) {
	if(prefName == "newtabenabled")
	{
		if(prefSet.prefs['newtabenabled'])
		{
			SearchSettings.setPref("browser.newtab.url", "http://www.ecosia.org/?addon=firefox&ref=newtab-search");
		}else{
			SearchSettings.setPref("browser.newtab.url", "about:newtab");
		}
	}else if(prefName == "keepdefault")
	{
		SearchSettings.cleanup('uninstall');
		if(prefSet.prefs['newtabenabled'])
		{
			SearchSettings.setPref("browser.newtab.url", "http://www.ecosia.org/?addon=firefox&ref=newtab-search");
		}
		SearchSettings.addSearchEngine(ENGINE_URL, prefSet.prefs['keepdefault']);
	}
}
function loadPageMod() {
    var pageMod = require("page-mod");
    pageModGoogle = pageMod.PageMod({
        include: /^https?:\/\/(www|encrypted)\.google\..*\/.*$/,
        contentScriptWhen: 'ready',
        contentScriptFile: [
			data.url("js/jquery.js"),
            data.url("js/google.js")			
        ],
		onAttach: function(worker) {
			worker.port.on("translate", function handleMyMessage(myMessagePayload) {
				worker.port.emit("translated",strings.GetStringFromName(myMessagePayload));
			});
		}
	});
	pageModFB = pageMod.PageMod({
        include: /^https?:\/\/(www|encrypted)\.facebook\.com\//,
        contentScriptWhen: 'ready',
        contentScriptFile: [
			data.url("js/jquery.js"),
            data.url("js/facebook.js")			
        ],
		onAttach: function(worker) {
			worker.port.on("get", function handleMyMessage(myMessagePayload) {
				if(myMessagePayload == "FBmsg")
				{
					var newpayload = new Array ();
					if(prefSet.prefs['FBmsg']<2){newpayload[0] = true;} else{ newpayload[0] = false;}
					newpayload[1] = parseInt(prefSet.prefs['FBdate'],10);
					newpayload[2] = strings.GetStringFromName("support_string");
					newpayload[3] = strings.GetStringFromName("spread_string");
					newpayload[4] = strings.GetStringFromName("share_string");
					if(prefSet.prefs['userid']==0){var x = getRandom(100000000,999999999); newpayload[5] = x; prefSet.prefs['userid']=x;} else{ newpayload[5] = prefSet.prefs['userid'];}
					worker.port.emit("FBreturn",newpayload);
				}
			});
			worker.port.on("set", function handleMyMessage(myMessagePayload) {
				if(myMessagePayload == "FBmsg")
				{
					prefSet.prefs['FBmsg'] = prefSet.prefs['FBmsg']+1;
				}
				else if(myMessagePayload == "FBdate")
				{
					var lastclose = new Date().getTime();
					prefSet.prefs['FBdate'] = lastclose.toString();
				}
			});
		}
	});
	pageModTW = pageMod.PageMod({
        include: /^https?:\/\/twitter\.com\//,
        contentScriptWhen: 'ready',
        contentScriptFile: [
			data.url("js/jquery.js"),
            data.url("js/twitter.js")			
        ],
		onAttach: function(worker) {
			worker.port.on("get", function handleMyMessage(myMessagePayload) {
				if(myMessagePayload == "TWmsg")
				{
					var newpayload = new Array ();
					if(prefSet.prefs['TWmsg']<2){newpayload[0] = true;} else{ newpayload[0] = false;}
					newpayload[1] = parseInt(prefSet.prefs['TWdate'],10);
					newpayload[2] = strings.GetStringFromName("sharetw_string");
					newpayload[3] = strings.GetStringFromName("spread_string");
					newpayload[4] = strings.GetStringFromName("composetw_string");
					if(prefSet.prefs['userid']==0){var x = getRandom(100000000,999999999); newpayload[5] = x; prefSet.prefs['userid']=x;} else{ newpayload[5] = prefSet.prefs['userid'];}
					newpayload[6] = strings.GetStringFromName("tweettext_string");
					worker.port.emit("TWreturn",newpayload);
				}
			});
			worker.port.on("set", function handleMyMessage(myMessagePayload) {
				if(myMessagePayload == "TWmsg")
				{
					prefSet.prefs['TWmsg'] = prefSet.prefs['TWmsg']+1;
				}
				else if(myMessagePayload == "TWdate")
				{
					var lastclose = new Date().getTime();
					prefSet.prefs['TWdate'] = lastclose.toString();
				}
			});
		}
	});
}
function getRandom(min, max) {
	if(min > max) {
		return -1;
	}
	if(min == max) {
		return min;
	}
	var r;
	do {
		r = Math.random();
	}
	while(r == 1.0);
	return min + parseInt(r * (max-min+1));
}
exports.onUnload = function (reason) {
	SearchSettings.cleanup('uninstall');
	if(reason == "uninstall") tabs.open("http://www.ecosia.org/?uninstall=firefox");
}